/* Example: pointers and arrays */

#include <stdio.h>

main()
{
  int arr[5] = {65, 28, 74, 22, 82};  /* declare an array of ints */
  int *ptr1, *ptr2;                   /* and two pointers to an int */
  int i;
  
  ptr1 = arr;      /* set pointer ptr1 to point at the array, 
                   i.e. ptr1 contains the address of arr[0], 
                   and arr[0] is the "pointee" of ptr1.
                   (Note that arr is itself a pointer.) 
                   We could also write ptr1 = &arr[0]; */

  ptr2 = &arr[4];  /* set pointer ptr2 to point at the last
                   element in the array, i.e. ptr2 contains the 
                   address of arr[4], and arr[4] is the "pointee" 
                   of ptr2. */

  /* We now have several ways of accessing the same array elements: */
  
  printf("arr[0] is %i, arr[4] is %i\n", arr[0], arr[4]);
  printf("*arr is %i, *(arr + 4) is %i\n", *arr, *(arr + 4));
  printf("*&arr[0] is %i, *&arr[4] is %i\n", *&arr[0], *&arr[4]);
  printf("*ptr1 is %i, *ptr2 is %i\n", *ptr1, *ptr2);
  printf("*(ptr2 - 4) is %i, *(ptr1 + 4) is %i\n", *(ptr2 - 4), *(ptr1 + 4));
  printf("ptr1[0] is %i, ptr1[4] is %i\n", ptr1[0], ptr1[4]);
  printf("ptr2[-4] is %i, ptr2[0] is %i\n\n", ptr2[-4], ptr2[0]);

  /* We can use them in loops, e.g.: */
  
  for (i = 0; i < 5; i++)
    printf("%i ", arr[i]);
  putchar('\n');
  
  for (i = 0; i < 5; i++)
    printf("%i ", *(arr + i));
  putchar('\n');
  
  for (i = 0; i < 5; i++)
    printf("%i ", ptr1[i]);
  putchar('\n');
  
  for (i = 0; i < 5; i++)
    printf("%i ", ptr2[i-4]);
  putchar('\n');
}
